clear all
clc
% T1: 15/150 kV, 50MVA, x=6%
% T2: 155/66/31.5 kV, 50/30/20 MVA, xps=3%, xpt=4%, xst=5% todas en base 50MVA
% G: 14kV, 60MVA, x=10%
% L: l=1mH/km, c=10nF/km, 100km
% Z1: Carga, modelo impedancia cte, consume 10MW con cos(fi)=0.9 capacitivo a tensin nominal (66kV).
% Z2: Carga, modelo impedancia cte, consume 4MW con cos(fi)=0.9 capacitivo a tensin nominal (31.5kV).

%% Bases
Sb=50; Ub150=150; Ub15=15; Ub66=150*66/155; Ub30=150*31.5/155;
Zb150=Ub150^2/Sb; Zb66=Ub66^2/Sb; Zb30=Ub30^2/Sb; Zb15=Ub15^2/Sb;

%% Datos
%xg=0.1j*(14^2/60)/Zb15;
xt1=0.06j;
xps=0.03j*155^2/Ub150^2; 
xpt=0.04j*155^2/Ub150^2; 
xst=0.05j*155^2/Ub150^2;

[xp,xs,xt]=Trafo3arr_1(xps,xpt,xst)

L=100;
xL=(1e-3)*2*pi*50*L/Zb150*j; 
yL=(10e-9)*2*pi*50*L*Zb150*j;

Un1=66; 
P1=10;
Q1=-P1*tan(acos(0.9)); 
z1=(P1+j*Q1)*Un1^2/abs(P1+j*Q1)^2/Zb66;

Un2=31.5; 
P2=4; 
Q2=-P2*tan(acos(0.9)); 
z2=(P2+j*Q2)*Un2^2/abs(P2+j*Q2)^2/Zb30;

uB=156/Ub150;

% Parte a
iB=uB/(xp+paralelo(xs+z1,xt+z2));
iL=iB+uB*yL/2;
uA=uB+iL*xL; 
UA=uA*Ub150, abs(UA)

% Parte b
ig=iL+uA*yL/2;
ug=uA+ig*xt1;
sg=ug*conj(ig); 
Sg=sg*Sb
